//*****************************************************************
// 
//  JAVA Source for com.idautomation.databar; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.databar;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
/** This is the DataBar servlet that creates a barcode from the DataBar class. */
public class IDAutomationServlet extends HttpServlet 
{
    /**
    * Handle the HTTP POST method by sending an e-mail
    */
    private boolean debug=false;
    public void init() throws ServletException  {	}
    // MODIFY THIS METHOD TO RETRIEVE DATA TO ENCODE, CREATE THE BARCODE AND SET THE PARAMETERS
    private DataBar getChart (HttpServletRequest request)
    {
        DataBar cb=new DataBar();
        if (request!=null) 
        {
            // Remark these parameters out if you do not need them. We also recommend fixing parameters so they
            // do not need to be defined in the barcode IMG string. For example, instead of 
            // if (request.getParameter("BAR_HEIGHT")!=null) cb.barHeightCM=new Double(request.getParameter("BAR_HEIGHT")).doubleValue();
            // use
            // cb.barHeightCM=2;
            // if you always use a bar height of 2.
            String st = null;
            if (request.getParameter("S")!=null) 
            {
                st = request.getParameter("S");
                if (st.toUpperCase().compareTo("CODE128")==0 || st.toUpperCase().compareTo("0")==0)
                    cb.setSymbologyID(cb.CODE128);
                if (st.toUpperCase().compareTo("DATABAR")==0 || st.toUpperCase().compareTo("1")==0)
                    cb.setSymbologyID(cb.DATABAR);
                if (st.toUpperCase().compareTo("DATABAREXPANDED")==0 || st.toUpperCase().compareTo("2")==0)
                    cb.setSymbologyID(cb.DATABAREXPANDED);
                if (st.toUpperCase().compareTo("DATABARLIMITED")==0 || st.toUpperCase().compareTo("3")==0)
                    cb.setSymbologyID(cb.DATABARLIMITED);
                if (st.toUpperCase().compareTo("DATABARSTACKED")==0 || st.toUpperCase().compareTo("4")==0)
                    cb.setSymbologyID(cb.DATABARSTACKED);
                if (st.toUpperCase().compareTo("DATABAROMNI")==0 || st.toUpperCase().compareTo("5")==0)
                    cb.setSymbologyID(cb.DATABAROMNI);
                if (st.toUpperCase().compareTo("DATABARTRUNCATED")==0 || st.toUpperCase().compareTo("6")==0)
                    cb.setSymbologyID(cb.DATABARTRUNCATED);
                if (st.toUpperCase().compareTo("EAN13")==0 || st.toUpperCase().compareTo("7")==0)
                    cb.setSymbologyID(cb.EAN13);
                if (st.toUpperCase().compareTo("EAN8")==0 || st.toUpperCase().compareTo("8")==0)
                    cb.setSymbologyID(cb.EAN8);
                if (st.toUpperCase().compareTo("MICROPDF417")==0 || st.toUpperCase().compareTo("9")==0)
                    cb.setSymbologyID(cb.MICROPDF417);
                if (st.toUpperCase().compareTo("PDF417")==0 || st.toUpperCase().compareTo("10")==0)
                    cb.setSymbologyID(cb.PDF417);
                if (st.toUpperCase().compareTo("UPCA")==0 || st.toUpperCase().compareTo("11")==0)
                    cb.setSymbologyID(cb.UPCA);
                if (st.toUpperCase().compareTo("UPCE")==0 || st.toUpperCase().compareTo("12")==0)
                    cb.setSymbologyID(cb.UPCE);
            }
            if (request.getParameter("SG")!=null) cb.setExpandedStackedSegments(new Integer(request.getParameter("SG")).intValue());
            if (request.getParameter("O")!=null) cb.rotate=new Integer(request.getParameter("O")).intValue();
            if (request.getParameter("BH")!=null) cb.barHeightCM=new Double(request.getParameter("BH")).doubleValue();
            if (request.getParameter("X")!=null) cb.X_DimensionCM=new Double(request.getParameter("X")).doubleValue();
            if (request.getParameter("LM")!=null) cb.leftMarginCM=new Double(request.getParameter("LM")).doubleValue();
            if (request.getParameter("TM")!=null) cb.topMarginCM=new Double(request.getParameter("TM")).doubleValue();
            if (request.getParameter("EM")!=null) cb.textMarginCM=new Float(request.getParameter("EM")).floatValue();
            if (request.getParameter("F")!=null) cb.textFont=new Font(request.getParameter("F"),Font.PLAIN,cb.textFont.getSize());
            if (request.getParameter("FS")!=null) cb.textFont=cb.textFont.deriveFont(new Float(request.getParameter("FS")).floatValue());
            if (request.getParameter("FC")!=null) cb.fontColor=convertColor(request.getParameter("FC"));
            if (request.getParameter("BC")!=null) cb.barColor=convertColor(request.getParameter("BC"));
            if (request.getParameter("BGC")!=null) cb.backColor=convertColor(request.getParameter("BGC"));
            if (request.getParameter("ECL")!=null) cb.ecLevel=new Integer(request.getParameter("ECL")).intValue();
            if (request.getParameter("COL")!=null) cb.setPDFColumns(new Integer(request.getParameter("COL")).intValue());
            if (request.getParameter("CG")!=null) cb.setCharacterGrouping(new Integer(request.getParameter("CG")).intValue());
            if (request.getParameter("IR")!=null) cb.setPixelsPerCM(new Integer(request.getParameter("IR")).intValue());
            if (request.getParameter("XYR")!=null) cb.setXtoYRatio(new Integer(request.getParameter("XYR")).intValue());
            if (request.getParameter("DSH")!=null)
            {
                String STParameter = request.getParameter("DSH");
                if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                   STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                    cb.setDataBarSuggestedHeight(true);
                else
                    cb.setDataBarSuggestedHeight(false);
            }
            if (request.getParameter("CS")!=null) 
            {
                char csParam = request.getParameter("CS").charAt(0);
                if(csParam >= '0' && csParam <= '3')
                {
                    switch(csParam)
                    {
                        case '0':
                        {
                            cb.setCode128Set(String.valueOf("AUTO"));
                            break;
                        }
                        case '1':
                        {
                            cb.setCode128Set(String.valueOf("A"));
                            break;
                        }
                        case '2':
                        {
                            cb.setCode128Set(String.valueOf("B"));
                            break;
                        }
                        case '3':
                        {
                            cb.setCode128Set(String.valueOf("C"));
                            break;
                        }
                    }
                }
                else
                    cb.setCode128Set(String.valueOf(csParam));
            }
            
            if (request.getParameter("AI")!=null)
            {
                String AIParameter = request.getParameter("AI");
                if(AIParameter.toUpperCase().compareTo("Y") == 0 || AIParameter.toUpperCase().compareTo("YES") == 0 ||
                   AIParameter.toUpperCase().compareTo("TRUE") == 0 || AIParameter.toUpperCase().compareTo("T") == 0)
                    cb.includeAIinHRText = true;
                else
                    cb.includeAIinHRText = false;
            }
            if (request.getParameter("L")!=null) 
            {
                String LParameter = request.getParameter("L");
                if(LParameter.toUpperCase().compareTo("Y") == 0 || LParameter.toUpperCase().compareTo("YES") == 0 ||
                   LParameter.toUpperCase().compareTo("TRUE") == 0 || LParameter.toUpperCase().compareTo("T") == 0)
                    cb.includeLinkageFlaginHRText = true;
                else
                    cb.includeLinkageFlaginHRText = false;
            }
            if (request.getParameter("ST")!=null)
            {
                String STParameter = request.getParameter("ST");
                if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                   STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                    cb.showText = true;
                else
                    cb.showText = false;
            }
            if (request.getParameter("TA")!=null)
            {
                String STParameter = request.getParameter("TA");
                if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                   STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                    cb.showTextLocation = cb.TOP;
                else
                    cb.showTextLocation = cb.BOTTOM;
            }
            if (request.getParameter("PT")!=null)
            {
                String PTParameter = request.getParameter("PT");
                if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                   PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                    cb.applyTilde = true;
                else
                    cb.applyTilde = false;
                
            }
            if (request.getParameter("CD")!=null) 
            {
                cb.isComposite = true;
                cb.compositeData=new String(request.getParameter("CD"));
            }
            if (request.getParameter("MODE")!=null) 
            {
                st = request.getParameter("MODE");
                if(st.toUpperCase().compareTo("TEXT")==0) cb.compactionMode = 0;
                if(st.toUpperCase().compareTo("BINARY")==0) cb.compactionMode = 1;
                if(st.toUpperCase().compareTo("NUMERIC")==0) cb.compactionMode = 2;
            }

            if (request.getParameter("D")!=null) 
            {
                cb.code=request.getParameter("D");
            }
            else  
            {
                cb.code="123456789012";
            }
        }
        else  
        {
            cb.code="No Data";
        }
        return cb;
    }

    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }

    // Handle the request
    // 1. create barcode
    // 2. draw barcode in a Buffered Image
    // 3. encode image as GIF or JPEG and send it to the browser
    public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
    {
        PrintWriter out;
        ServletOutputStream outb;
        //default encoding type
        String encode="gif";
        if (request!=null) 
        {
            if (request.getParameter("I")!=null)  
                encode=request.getParameter("I").toLowerCase();
            if (encode.compareTo("jpeg")==0) encode="jpeg";
        }
        response.setContentType("image/"+encode);
        outb=response.getOutputStream();
        // avoid caching in browser
        response.setHeader ("Pragma", "no-cache");
        response.setHeader ("Cache-Control", "no-cache");
        response.setDateHeader ("Expires",0);
        try 
        { 
            // find sizes
            int w=10;
            int h=10;
            // get the BarCode
            DataBar cb=getChart(request);
            if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) 
            {
                cb.autoSize = false;
                w=new Integer(request.getParameter("W")).intValue();
                h=new Integer(request.getParameter("H")).intValue();
            }
            else 
            {
                //a temp image must be created to find the preferred size
                cb.setSize(600,90);
                java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
                java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
                cb.paint(imgTempGraphics);
                cb.invalidate();
                w=cb.getSize().width;
                h=cb.getSize().height;
                imgTempGraphics.dispose();
            }
            java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
            java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
            if (debug) System.out.println("Size: "+w+" "+h);
            cb.setSize(w,h);
            cb.paint(BarGraphics);
            if (encode.compareToIgnoreCase("gif")==0) 
            {
                // encode buffered image to a gif
                com.idautomation.databar.encoder.GifEncoder encoder = new com.idautomation.databar.encoder.GifEncoder(BarImage  ,outb);
                encoder.encode();
            }
            else
            {
                // create JPEG image
                com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                //increase the JPEG quality to 100%
                com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( BarImage); 
                param.setQuality(1.0F,true);
                encoder.setJPEGEncodeParam(param);
                encoder.encode( BarImage,param  );
            }
        } 
        catch (Exception e) { e.printStackTrace();}
    }

    public void doPost (HttpServletRequest request, HttpServletResponse response) throws ServletException
    {
        try 
        {
            doGet(request,response);
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }
}